vs.1.1

// Compute a real value that's influenced by the position and the time. The squared 
// cosine of this value will be a factor describing the wind strength at the current 
// time and position.
mul r0.w, v0.x, c14.x
mov r0.x, c8.x
mad r0.w, r0.x, c14.y, r0.w
// For any real value x in r0.w the following code leads to an extremely precise 
// approximation of cos(x). It uses the Taylor series. 
// cos(x) ~= 1 - 1/2*x^2 + 1/24*x^4 - 1/720*x^6 + 1/40320*x^8
// Bring r0.w into the range from -Pi to +Pi
mad r0.w, r0.w, c10.x, c10.z
frc r0.y, r0.w
mad r0.w, r0.y, c10.y, c10.w
// Do the approximation
mul r4.x, r0.w, r0.w
mul r4.y, r4.x, r4.x
mul r4.z, r4.y, r4.x
mul r4.w, r4.z, r4.x
dp4 r4, r4, c9
add r4, r4, c11.w

mul r4, r4, r4

// Compute a value that's influenced by the position and the time
mul r0.w, v0.x, c11.x
mov r0.x, c8.x
mad r0.w, r0.x, c11.y, r0.w
// For any real value x in r0.w the following code leads to an extremely precise 
// approximation of cos(x). It uses the Taylor series. 
// cos(x) ~= 1 - 1/2*x^2 + 1/24*x^4 - 1/720*x^6 + 1/40320*x^8
// Bring r0.w into the range from -Pi to +Pi
mad r2.w, r0.w, c10.x, c10.z
frc r2.y, r2.w
mad r2.w, r2.y, c10.y, c10.w
// Do the approximation
mul r1.x, r2.w, r2.w
mul r1.y, r1.x, r1.x
mul r1.z, r1.y, r1.x
mul r1.w, r1.z, r1.x
dp4 r1, r1, c9
add r1, r1, c11.w

mul r1, r1, r1

// Multiply the above combination of place and time by a constant factor
mul r1.w, r0.w, c11.z
// For any real value x in r1.w the following code leads to an extremely precise 
// approximation of cos(x). It uses the Taylor series. 
// cos(x) ~= 1 - 1/2*x^2 + 1/24*x^4 - 1/720*x^6 + 1/40320*x^8
// Bring r1.w into the range from -Pi to +Pi
mad r1.w, r1.w, c10.x, c10.z
frc r1.y, r1.w
mad r1.w, r1.y, c10.y, c10.w
// Do the approximation
mul r2.x, r1.w, r1.w
mul r2.y, r2.x, r2.x
mul r2.z, r2.y, r2.x
mul r2.w, r2.z, r2.x
dp4 r2, r2, c9
add r2, r2, c11.w


// Use the resulting cosines to manipulate the vertex position
mov r5, v0
sub r6.w, c11.w, v7.y
mul r6.w, r6.w, r6.w
mul r6.z, r1.z, r6.w
mul r6.z, r6.z, r4
mad r5.xyz, r6.z, c12, r5
mul r6.z, r2.z, r6.w
mul r6.z, r6.z, r4
mad r5.xyz, r6.z, c13, r5

// Compute the projection space position of the vertex
m4x4 oPos, r5, c0
// Pass the first texture coordinate set
mov oT0, v7

// Compute the lighting
dp3 r0, v3, c6
max r0, c8.z, r0
mul r0, r0, c7
mov r1, c4
add r0, c15, r0
mad oD0, r0, r1, c5
